<?php
require 'AbstractUIGenerator.php';
require 'ActionQuantik.php';
require 'ArrayPieceQuantik.php';
require 'PieceQuantik.php';
require 'PlateauQuantik.php';
require 'Player.php';
require 'QuantikGame.php';
require 'QuantikUIGenerator.php';
require_once 'PDOQuantik.php';

ini_set('display_errors', 1);
ini_set('error_reporting', E_ALL);

session_start();
//print_r($_SESSION);
//print_r($_POST);
$action = $_POST['action'];
switch ($action) {
    case "creerPartie":
        require_once 'db.php';
        PDOQuantik::initPDO($_ENV['sgbd'],$_ENV['host'],$_ENV['database'],$_ENV['user'],$_ENV['password']);
        $partie = new QuantikGame(array($_SESSION['player']));
        $json = $partie->getJson();
        PDOQuantik::createGameQuantik($_SESSION['player']->id, $json);
        $_SESSION['etat'] = 'home';
        header('Location: indext.php');
        break;
    case "continuerPartie":
        require_once 'db.php';
        $gameId = intval($_POST['gameid']);
        PDOQuantik::initPDO($_ENV['sgbd'],$_ENV['host'],$_ENV['database'],$_ENV['user'],$_ENV['password']);
        $game = PDOQuantik::getGameQuantikById($gameId);
        $data = json_decode($game->getJson());
        //print_r($data);
        $_SESSION['game'] = $game;
        if ($game->gameStatus !== 'finished') {
            $currentPlayer = $data->couleursPlayers[$data->currentPlayer]->name;
            if ($_SESSION['player']->name == $currentPlayer) {
                $_SESSION['etat'] = 'choixPiece';
            } else {
                $_SESSION['etat'] = 'consulterPartieEnCours';
            }
        } else {
            $_SESSION['etat'] = 'consulterPartieVictoire';
        }
        header('Location: indext.php');
        break;
    case "rejoindrePartie":
        $gameId = intval($_POST['gameid']);
        require_once 'db.php';
        PDOQuantik::initPDO($_ENV['sgbd'],$_ENV['host'],$_ENV['database'],$_ENV['user'],$_ENV['password']);
        $partie = PDOQuantik::getGameQuantikById($gameId);
        $partie->couleurPlayer[] = $_SESSION['player'];
        $json = $partie->getJson();
        PDOQuantik::addPlayerToGameQuantik($_SESSION['player']->id,$json,$gameId);
        $partie->setStatus('waitingForPlayer');
        $json = $partie->getJson();
        PDOQuantik::saveGameQuantik('waitingForPlayer',$json,$gameId);
        header('Location: indext.php');
        break;
    case "consulterPartie":

        header('Location: indext.php');
        break;
    case "quitter":
        session_destroy();
        header('Location: login.php');
        break;

    default:
        $_SESSION['etat'] = 'erreur';
        header('Location: indext.php');
        break;
}